
# Code Guardian

**Guard your code with swarms of agents**

[![Join our Discord](https://img.shields.io/badge/Discord-Join%20our%20server-5865F2?style=for-the-badge&logo=discord&logoColor=white)](https://discord.gg/agora-999382051935506503) [![Subscribe on YouTube](https://img.shields.io/badge/YouTube-Subscribe-red?style=for-the-badge&logo=youtube&logoColor=white)](https://www.youtube.com/@kyegomez3242) [![Connect on LinkedIn](https://img.shields.io/badge/LinkedIn-Connect-blue?style=for-the-badge&logo=linkedin&logoColor=white)](https://www.linkedin.com/in/kye-g-38759a207/) [![Follow on X.com](https://img.shields.io/badge/X.com-Follow-1DA1F2?style=for-the-badge&logo=x&logoColor=white)](https://x.com/kyegomezb)


**CodeGuardian** is an intelligent agent designed to automate the generation of production-grade unit tests for your Python code. It not only creates and runs these tests but also monitors them in real-time, providing you with comprehensive summaries of your code health. With CodeGuardian, you can enhance code reliability, maintainability, and accelerate your development workflow.

## Features

- **Automated Test Generation**: Automatically generate unit tests for your existing Python codebase.
- **Test Execution**: Run generated tests seamlessly and view results instantly.
- **Real-Time Monitoring**: Watch tests in real-time to observe code behavior and performance.
- **Code Health Summaries**: Receive detailed reports on test coverage, code quality, and potential issues.
- **Easy Integration**: Integrate effortlessly with existing projects and CI/CD pipelines.
- **Customizable Configurations**: Tailor settings to match your project requirements.


### Prerequisites

- **Python 3.7** or higher
- **pip** package manager


## Installation
```bash
pip3 install -U code-guardian
```




### Configuration Options

- **test_directory**: Directory where tests are stored.
- **source_directory**: Directory containing your source code.
- **exclude_patterns**: Files or directories to exclude.
- **report_format**: Format of the code health report (`html`, `json`, `xml`).
- **watch**: Settings for real-time monitoring.


## Roadmap

- **Multi-language Support**: Extend functionality to other programming languages.
- **Advanced Static Analysis**: Integrate deeper code analysis tools.
- **IDE Plugins**: Develop plugins for popular IDEs like VSCode and PyCharm.
- **Enhanced Reporting**: Add more detailed metrics and visualizations.

## Contributing

We welcome contributions! Please see our [Contributing Guidelines](CONTRIBUTING.md) for details on how to get started.

## License

CodeGuardian is licensed under the [MIT License](LICENSE).

## Acknowledgements

- Inspired by the need for robust automated testing tools.
- Thanks to the open-source community for their invaluable contributions.
